//  Xg12.7 TimergAj[V
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class TimerAnimation extends JPanel implements ActionListener {
    int number = -1;
    int cell = 20;
    int interval;
    Image[] image;
    MediaTracker tracker;
    Timer timer;

    TimerAnimation() {
        //C[W̃[h
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        tracker = new MediaTracker(this);
        image = new Image[cell];
        for (int i = 1; i <= cell; i++) {
           image[i-1] = 
              toolkit.getImage("rabbit/rabbit" + i + ".gif");
           tracker.addImage(image[i-1], 0);
        }
        
        interval = 150;                    //`̊Ԋu(~b)
        timer = new Timer(interval, this); //^C}[̐
        timer.setInitialDelay(0);          //Ɏn߂
        timer.setCoalesce(true);           //Cxg܂Ƃ߂
     
        setBackground(Color.white);       //pl̔wiF
        try{         
           tracker.waitForAll();          //[hJn
	    }catch(InterruptedException e){ return; }
        startAnimation();                 //Aj[V̊Jn
    }

    public synchronized void startAnimation() {
       if (!timer.isRunning()) {
               timer.start();       //Aj[V̊Jn
       }
    }

    public synchronized void stopAnimation() {
        if (timer.isRunning()) {
            timer.stop();          //Aj[V~߂
        }
    }

    public void actionPerformed(ActionEvent e) { //ANVCxg
        number++;  //ɕ\C[W̒ʂԍ
        repaint(); //`
    }

    public void paintComponent(Graphics g) {
       super.paintComponent(g); //wi̕`
       int x = getWidth()/2-30; //EBhÊقڒɃC[W\
       int y = getHeight()/2-30;
       try {
           g.drawImage(image[number%cell], x, y, this);
       } catch (ArrayIndexOutOfBoundsException e) { return; }
                        //number-1̎ɕ`悪Ă΂ꂽ̗O
    }

    public static void main(String[] args) {
        JFrame f = new JFrame("Timer Animation");
        TimerAnimation anime = new TimerAnimation();
        f.getContentPane().add(anime, BorderLayout.CENTER);
        f.setSize(new Dimension(100, 100));
        f.setVisible(true);
    }
}





