import java.awt.Color;

public class Stepper extends Turtle{
  public int n;               //CX^Xϐ n ̐錾
  public int size;      //CX^Xϐ size ̐錾
  private int j = 0;              //ijCX^Xϐ j ̐錾
  public static final int ALREADY_FIN = 0;
  public static final int JUST_FIN = 1;
  public static final int  NOT_FIN = 2;

  /** x, y ƂW angle ̊px Stepper 𐶐 */
  Stepper(int x, int y, int angle, int n, int size)
    {
      super(x, y, angle);    //Turtle ̃RXgN^Ăяo
      this.n = n;            //CX^Xϐ n   n ݒ
      this.size = size;      //CX^Xϐ size ̐ݒ
    }

  /** n = 4, size = 100  Stepper 쐬 */
  Stepper(int x, int y, int angle)
    {
      this(x, y, angle, 4, 100); //L̃RXgN^Ăяo
    }

  /** 0 ̃RXgN^ */
  Stepper() {   super();}    //ʃRXgN^Ăяo
  
  public int step()
  {
    if(j >= n)
        return ALREADY_FIN;         //`IĂȂ炷I
    fd(size);
    rt(360/n);
    if(++j == n)       //j1₷Ƃ n Ɣr邱Ƃ1̎ōs
        return JUST_FIN;  
    return NOT_FIN;                  //ɗ̂́C2 if ̏𖞂ȂƂ
  }
  public void reset() { j = 0; }

  public static void main(String[] args){
    TurtleFrame f = new TurtleFrame(600,300);
    int[] size = {100,28,90,40,2,100,40,2, 30, 20};
    int[] n = {6, 5, 3,10,20,3,4,5,3,5};
    Color[] c = {Color.black, Color.blue, Color.cyan, Color.darkGray};
    Stepper[] hm = new Stepper[10];
    for(int i = 0 ; i < 10; i++){
      hm[i] = new Stepper(i * 50 + 25,150,0, n[i], size[i]);
      hm[i].setColor(c[i % c.length]);
      f.add(hm[i]);
    }
    for(int j = 0; j < 20; j++){
      for(int i = 0; i < 10; i++){
	hm[i].step();
      }
    }
  }

}
